package Centurion.lib.jazzlib;

public final class Adler32
{
    private int anInt1127;
    
    public Adler32() {
        super();
        this.reset();
    }
    
    public final void reset() {
        this.anInt1127 = 1;
    }
    
    public final void update(final byte[] array, int n, int i) {
        int n2 = this.anInt1127 & 0xFFFF;
        int n3 = this.anInt1127 >>> 16;
        while (i > 0) {
            int n4 = 3800;
            if (3800 > i) {
                n4 = i;
            }
            i -= n4;
            while (--n4 >= 0) {
                n2 += (array[n++] & 0xFF);
                n3 += n2;
            }
            n2 %= 65521;
            n3 %= 65521;
        }
        this.anInt1127 = (n3 << 16 | n2);
    }
    
    public final long getValue() {
        return this.anInt1127 & 0xFFFFFFFFL;
    }
}
