package Centurion.lib.jazzlib;

final class DeflaterEngine implements DeflaterConstants
{
    private int anInt1042;
    private short[] aShortArray1043;
    private short[] aShortArray1044;
    private int anInt1045;
    private int anInt1046;
    private boolean aBoolean1047;
    private int anInt1048;
    private int anInt1049;
    private int anInt1050;
    private byte[] aByteArray1051;
    private int anInt1052;
    private int anInt1053;
    private int anInt1054;
    private int anInt1055;
    private int anInt1056;
    private int anInt1057;
    private byte[] aByteArray1058;
    private long aLong1059;
    private int anInt1060;
    private int anInt1061;
    private DeflaterPending aClass107_Sub1_2_1039;
    private Class84 aClass84_1040;
    private Adler32 aClass92_1041;
    
    DeflaterEngine(final DeflaterPending aClass107_Sub1_2_1039) {
        super();
        this.aClass107_Sub1_2_1039 = aClass107_Sub1_2_1039;
        this.aClass84_1040 = new Class84(aClass107_Sub1_2_1039);
        this.aClass92_1041 = new Adler32();
        this.aByteArray1051 = new byte[65536];
        this.aShortArray1043 = new short[32768];
        this.aShortArray1044 = new short[32768];
        final boolean b = true;
        this.anInt1049 = (b ? 1 : 0);
        this.anInt1048 = (b ? 1 : 0);
    }
    
    public final void reset() {
        this.aClass84_1040.method791();
        this.aClass92_1041.reset();
        final boolean b = true;
        this.anInt1049 = (b ? 1 : 0);
        this.anInt1048 = (b ? 1 : 0);
        this.anInt1050 = 0;
        this.aLong1059 = 0L;
        this.aBoolean1047 = false;
        this.anInt1046 = 2;
        for (int i = 0; i < 32768; ++i) {
            this.aShortArray1043[i] = 0;
        }
        for (int j = 0; j < 32768; ++j) {
            this.aShortArray1044[j] = 0;
        }
    }
    
    public final void resetAdler() {
        this.aClass92_1041.reset();
    }
    
    public final int getAdler() {
        return (int)this.aClass92_1041.getValue();
    }
    
    public final long getTotalIn() {
        return this.aLong1059;
    }
    
    public final void setStrategy(final int anInt1052) {
        this.anInt1052 = anInt1052;
    }
    
    public final void setLevel(final int n) {
        this.anInt1056 = DeflaterConstants.anIntArray1221[n];
        this.anInt1054 = DeflaterConstants.anIntArray1222[n];
        this.anInt1055 = DeflaterConstants.anIntArray1223[n];
        this.anInt1053 = DeflaterConstants.anIntArray1224[n];
        if (DeflaterConstants.anIntArray1225[n] != this.anInt1057) {
            switch (this.anInt1057) {
                case 0:
                    if (this.anInt1049 > this.anInt1048) {
                        this.aClass84_1040.method792(this.aByteArray1051, this.anInt1048, this.anInt1049 - this.anInt1048, false);
                        this.anInt1048 = this.anInt1049;
                    }
                    this.method767();
                    break;
                case 1:
                    if (this.anInt1049 > this.anInt1048) {
                        this.aClass84_1040.method796(this.aByteArray1051, this.anInt1048, this.anInt1049 - this.anInt1048, false);
                        this.anInt1048 = this.anInt1049;
                        break;
                    }
                    break;
                case 2:
                    if (this.aBoolean1047) {
                        this.aClass84_1040.method798(this.aByteArray1051[this.anInt1049 - 1] & 0xFF);
                    }
                    if (this.anInt1049 > this.anInt1048) {
                        this.aClass84_1040.method796(this.aByteArray1051, this.anInt1048, this.anInt1049 - this.anInt1048, false);
                        this.anInt1048 = this.anInt1049;
                    }
                    this.aBoolean1047 = false;
                    this.anInt1046 = 2;
                    break;
            }
            this.anInt1057 = DeflaterConstants.anIntArray1225[n];
        }
    }
    
    private void method767() {
        this.anInt1042 = (this.aByteArray1051[this.anInt1049] << 5 ^ this.aByteArray1051[this.anInt1049 + 1]);
    }
    
    private int method768() {
        final int anInt1042 = (this.anInt1042 << 5 ^ this.aByteArray1051[this.anInt1049 + 2]) & 0x7FFF;
        final short n = this.aShortArray1044[this.anInt1049 & 0x7FFF] = this.aShortArray1043[anInt1042];
        this.aShortArray1043[anInt1042] = (short)this.anInt1049;
        this.anInt1042 = anInt1042;
        return n & 0xFFFF;
    }
    
    private void method769() {
        System.arraycopy(this.aByteArray1051, 32768, this.aByteArray1051, 0, 32768);
        this.anInt1045 -= 32768;
        this.anInt1049 -= 32768;
        this.anInt1048 -= 32768;
        for (int i = 0; i < 32768; ++i) {
            final int n = this.aShortArray1043[i] & 0xFFFF;
            this.aShortArray1043[i] = (short)((n >= 32768) ? ((short)(n - 32768)) : 0);
        }
        for (int j = 0; j < 32768; ++j) {
            final int n2 = this.aShortArray1044[j] & 0xFFFF;
            this.aShortArray1044[j] = (short)((n2 >= 32768) ? ((short)(n2 - 32768)) : 0);
        }
    }
    
    private void method770() {
        if (this.anInt1049 >= 65274) {
            this.method769();
        }
        while (this.anInt1050 < 262 && this.anInt1060 < this.anInt1061) {
            int n;
            if ((n = 65536 - this.anInt1050 - this.anInt1049) > this.anInt1061 - this.anInt1060) {
                n = this.anInt1061 - this.anInt1060;
            }
            System.arraycopy(this.aByteArray1058, this.anInt1060, this.aByteArray1051, this.anInt1049 + this.anInt1050, n);
            this.aClass92_1041.update(this.aByteArray1058, this.anInt1060, n);
            this.anInt1060 += n;
            this.aLong1059 += n;
            this.anInt1050 += n;
        }
        if (this.anInt1050 >= 3) {
            this.method767();
        }
    }
    
    private boolean method762(int anInt1045) {
        int anInt1046 = this.anInt1053;
        int n = this.anInt1055;
        final short[] aShortArray1044 = this.aShortArray1044;
        int n2 = this.anInt1049;
        int n3 = this.anInt1049 + this.anInt1046;
        int max = Math.max(this.anInt1046, 2);
        final int max2 = Math.max(this.anInt1049 - 32506, 0);
        final int n4 = n2 + 258 - 1;
        byte b = this.aByteArray1051[n3 - 1];
        byte b2 = this.aByteArray1051[n3];
        if (max >= this.anInt1056) {
            anInt1046 >>= 2;
        }
        if (n > this.anInt1050) {
            n = this.anInt1050;
        }
        do {
            if (this.aByteArray1051[anInt1045 + max] == b2 && this.aByteArray1051[anInt1045 + max - 1] == b && this.aByteArray1051[anInt1045] == this.aByteArray1051[n2]) {
                if (this.aByteArray1051[anInt1045 + 1] != this.aByteArray1051[n2 + 1]) {
                    continue;
                }
                int n5 = anInt1045 + 2;
                n2 += 2;
                while (this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && this.aByteArray1051[++n2] == this.aByteArray1051[++n5] && n2 < n4) {}
                if (n2 > n3) {
                    this.anInt1045 = anInt1045;
                    n3 = n2;
                    if ((max = n2 - this.anInt1049) >= n) {
                        break;
                    }
                    b = this.aByteArray1051[n3 - 1];
                    b2 = this.aByteArray1051[n3];
                }
                n2 = this.anInt1049;
            }
        } while ((anInt1045 = (aShortArray1044[anInt1045 & 0x7FFF] & 0xFFFF)) > max2 && --anInt1046 != 0);
        this.anInt1046 = Math.min(max, this.anInt1050);
        return this.anInt1046 >= 3;
    }
    
    private boolean method760(final boolean b, final boolean b2) {
        if (!b && this.anInt1050 == 0) {
            return false;
        }
        this.anInt1049 += this.anInt1050;
        this.anInt1050 = 0;
        int anInt1220;
        if ((anInt1220 = this.anInt1049 - this.anInt1048) >= DeflaterConstants.anInt1220 || (this.anInt1048 < 32768 && anInt1220 >= 32506) || b) {
            boolean b3 = b2;
            if (anInt1220 > DeflaterConstants.anInt1220) {
                anInt1220 = DeflaterConstants.anInt1220;
                b3 = false;
            }
            this.aClass84_1040.method792(this.aByteArray1051, this.anInt1048, anInt1220, b3);
            this.anInt1048 += anInt1220;
            return !b3;
        }
        return true;
    }
    
    private boolean method763(final boolean b, final boolean b2) {
        if (this.anInt1050 < 262 && !b) {
            return false;
        }
        while (this.anInt1050 >= 262 || b) {
            if (this.anInt1050 == 0) {
                this.aClass84_1040.method796(this.aByteArray1051, this.anInt1048, this.anInt1049 - this.anInt1048, b2);
                this.anInt1048 = this.anInt1049;
                return false;
            }
            if (this.anInt1049 > 65274) {
                this.method769();
            }
            final int method768;
            if (this.anInt1050 >= 3 && (method768 = this.method768()) != 0 && this.anInt1052 != 2 && this.anInt1049 - method768 <= 32506 && this.method762(method768)) {
                final boolean method769 = this.aClass84_1040.method793(this.anInt1049 - this.anInt1045, this.anInt1046);
                this.anInt1050 -= this.anInt1046;
                if (this.anInt1046 <= this.anInt1054 && this.anInt1050 >= 3) {
                    while (--this.anInt1046 > 0) {
                        ++this.anInt1049;
                        this.method768();
                    }
                    ++this.anInt1049;
                }
                else {
                    this.anInt1049 += this.anInt1046;
                    if (this.anInt1050 >= 2) {
                        this.method767();
                    }
                }
                this.anInt1046 = 2;
                if (!method769) {
                    continue;
                }
            }
            else {
                this.aClass84_1040.method798(this.aByteArray1051[this.anInt1049] & 0xFF);
                ++this.anInt1049;
                --this.anInt1050;
            }
            if (this.aClass84_1040.method797()) {
                final boolean b3 = b2 && this.anInt1050 == 0;
                this.aClass84_1040.method796(this.aByteArray1051, this.anInt1048, this.anInt1049 - this.anInt1048, b3);
                this.anInt1048 = this.anInt1049;
                return !b3;
            }
        }
        return true;
    }
    
    private boolean method765(final boolean b, final boolean b2) {
        if (this.anInt1050 < 262 && !b) {
            return false;
        }
        while (this.anInt1050 >= 262 || b) {
            if (this.anInt1050 == 0) {
                if (this.aBoolean1047) {
                    this.aClass84_1040.method798(this.aByteArray1051[this.anInt1049 - 1] & 0xFF);
                }
                this.aBoolean1047 = false;
                this.aClass84_1040.method796(this.aByteArray1051, this.anInt1048, this.anInt1049 - this.anInt1048, b2);
                this.anInt1048 = this.anInt1049;
                return false;
            }
            if (this.anInt1049 >= 65274) {
                this.method769();
            }
            final int anInt1045 = this.anInt1045;
            int anInt1046 = this.anInt1046;
            if (this.anInt1050 >= 3) {
                final int method768 = this.method768();
                if (this.anInt1052 != 2 && method768 != 0 && this.anInt1049 - method768 <= 32506 && this.method762(method768) && this.anInt1046 <= 5 && (this.anInt1052 == 1 || (this.anInt1046 == 3 && this.anInt1049 - this.anInt1045 > 4096))) {
                    this.anInt1046 = 2;
                }
            }
            if (anInt1046 >= 3 && this.anInt1046 <= anInt1046) {
                this.aClass84_1040.method793(this.anInt1049 - 1 - anInt1045, anInt1046);
                anInt1046 -= 2;
                do {
                    ++this.anInt1049;
                    --this.anInt1050;
                    if (this.anInt1050 >= 3) {
                        this.method768();
                    }
                } while (--anInt1046 > 0);
                ++this.anInt1049;
                --this.anInt1050;
                this.aBoolean1047 = false;
                this.anInt1046 = 2;
            }
            else {
                if (this.aBoolean1047) {
                    this.aClass84_1040.method798(this.aByteArray1051[this.anInt1049 - 1] & 0xFF);
                }
                this.aBoolean1047 = true;
                ++this.anInt1049;
                --this.anInt1050;
            }
            if (this.aClass84_1040.method797()) {
                int n = this.anInt1049 - this.anInt1048;
                if (this.aBoolean1047) {
                    --n;
                }
                final boolean b3 = b2 && this.anInt1050 == 0 && !this.aBoolean1047;
                this.aClass84_1040.method796(this.aByteArray1051, this.anInt1048, n, b3);
                this.anInt1048 += n;
                return !b3;
            }
        }
        return true;
    }
    
    public final boolean deflate(final boolean b, final boolean b2) {
        boolean b3 = false;
        do {
            this.method770();
            final boolean b4 = b && this.anInt1060 == this.anInt1061;
            switch (this.anInt1057) {
                case 0:
                    b3 = this.method760(b4, b2);
                    continue;
                case 1:
                    b3 = this.method763(b4, b2);
                    continue;
                case 2:
                    b3 = this.method765(b4, b2);
                    continue;
                default:
                    throw new Error();
            }
        } while (this.aClass107_Sub1_2_1039.isFlushed() && b3);
        return b3;
    }
    
    public final void setInput(final byte[] aByteArray1058, final int anInt1060, final int n) {
        if (this.anInt1060 < this.anInt1061) {
            throw new IllegalStateException("Old input was not completely processed");
        }
        final int anInt1061 = anInt1060 + n;
        if (0 > anInt1060 || anInt1060 > anInt1061 || anInt1061 > aByteArray1058.length) {
            throw new ArrayIndexOutOfBoundsException();
        }
        this.aByteArray1058 = aByteArray1058;
        this.anInt1060 = anInt1060;
        this.anInt1061 = anInt1061;
    }
    
    public final boolean needsInput() {
        return this.anInt1061 == this.anInt1060;
    }
}
