package Centurion.lib.jazzlib;

final class InflaterHuffmanTree
{
    private short[] tree;
    static InflaterHuffmanTree defLitLenTree;
    static InflaterHuffmanTree defDistTree;
    
    InflaterHuffmanTree(final byte[] array) throws DataFormatException {
        super();
        this.method848(array);
    }
    
    private void method848(final byte[] array) throws DataFormatException {
        final int[] array2 = new int[16];
        final int[] array3 = new int[16];
        for (int i = 0; i < array.length; ++i) {
            final byte b;
            if ((b = array[i]) > 0) {
                final int[] array4 = array2;
                final byte b2 = b;
                ++array4[b2];
            }
        }
        int n = 0;
        int n2 = 512;
        for (int j = 1; j <= 15; ++j) {
            array3[j] = n;
            n += array2[j] << 16 - j;
            if (j >= 10) {
                n2 += (n & 0x1FF80) - (array3[j] & 0x1FF80) >> 16 - j;
            }
        }
        if (n != 65536) {
            throw new DataFormatException("Code lengths don't add up properly.");
        }
        this.tree = new short[n2];
        int n3 = 512;
        for (int k = 15; k >= 10; --k) {
            for (int n4 = n & 0x1FF80, l = (n -= array2[k] << 16 - k) & 0x1FF80; l < n4; l += 128) {
                this.tree[Class84.method790(l)] = (short)(-n3 << 4 | k);
                n3 += 1 << k - 9;
            }
        }
        for (int n5 = 0; n5 < array.length; ++n5) {
            final byte b3;
            if ((b3 = array[n5]) != 0) {
                final int n6;
                int method790 = Class84.method790(n6 = array3[b3]);
                if (b3 <= 9) {
                    do {
                        this.tree[method790] = (short)(n5 << 4 | b3);
                    } while ((method790 += 1 << b3) < 512);
                }
                else {
                    final short n7 = this.tree[method790 & 0x1FF];
                    final int n8 = 1 << (n7 & 0xF);
                    final int n9 = -(n7 >> 4);
                    do {
                        this.tree[n9 | method790 >> 9] = (short)(n5 << 4 | b3);
                    } while ((method790 += 1 << b3) < n8);
                }
                array3[b3] = n6 + (1 << 16 - b3);
            }
        }
    }
    
    final int getSymbol(final StreamManipulator class96) throws DataFormatException {
        final int method851;
        if ((method851 = class96.peekBits(9)) >= 0) {
            final short n;
            if ((n = this.tree[method851]) >= 0) {
                class96.dropBits(n & 0xF);
                return n >> 4;
            }
            final int n2 = -(n >> 4);
            final int method852;
            if ((method852 = class96.peekBits(n & 0xF)) >= 0) {
                final short n3 = this.tree[n2 | method852 >> 9];
                class96.dropBits(n3 & 0xF);
                return n3 >> 4;
            }
            final int method853 = class96.method852();
            final short n4;
            if (((n4 = this.tree[n2 | class96.peekBits(method853) >> 9]) & 0xF) <= method853) {
                class96.dropBits(n4 & 0xF);
                return n4 >> 4;
            }
            return -1;
        }
        else {
            final int method854 = class96.method852();
            final short n5;
            if ((n5 = this.tree[class96.peekBits(method854)]) >= 0 && (n5 & 0xF) <= method854) {
                class96.dropBits(n5 & 0xF);
                return n5 >> 4;
            }
            return -1;
        }
    }
    
    static {
        try {
            byte[] array;
            int i;
            for (array = new byte[288], i = 0; i < 144; array[i++] = 8) {}
            while (i < 256) {
                array[i++] = 9;
            }
            while (i < 280) {
                array[i++] = 7;
            }
            while (i < 288) {
                array[i++] = 8;
            }
            InflaterHuffmanTree.defLitLenTree = new InflaterHuffmanTree(array);
            final byte[] array2 = new byte[32];
            for (int j = 0; j < 32; array2[j++] = 5) {}
            InflaterHuffmanTree.defDistTree = new InflaterHuffmanTree(array2);
        }
        catch (DataFormatException class90) {
            throw new Error("InflaterHuffmanTree: static tree length illegal");
        }
    }
}
