package Centurion.lib.jazzlib;

import java.io.*;

public class InflaterInputStream extends InputStream
{
    protected InputStream anInputStream1133;
    protected Inflater aClass88_1134;
    protected byte[] aByteArray1135;
    protected int anInt1136;
    private byte[] aByteArray1137;
    
    public InflaterInputStream(final InputStream inputStream, final Inflater class88) {
        this(inputStream, class88, 4096);
    }
    
    public InflaterInputStream(final InputStream in, final Inflater inf, final int size) {
        super();
        this.aByteArray1137 = new byte[1];
        this.anInputStream1133 = in;
        if (in == null) {
            throw new NullPointerException("in may not be null");
        }
        if (inf == null) {
            throw new NullPointerException("inf may not be null");
        }
        if (size < 0) {
            throw new IllegalArgumentException("size may not be negative");
        }
        this.aClass88_1134 = inf;
        this.aByteArray1135 = new byte[size];
    }
    
    public int available() throws IOException {
        if (this.aClass88_1134 == null) {
            throw new IOException("stream closed");
        }
        if (this.aClass88_1134.finished()) {
            return 0;
        }
        return 1;
    }
    
    public synchronized void close() throws IOException {
        if (this.anInputStream1133 != null) {
            this.anInputStream1133.close();
        }
        this.anInputStream1133 = null;
    }
    
    protected final void method850() throws IOException {
        if (this.anInputStream1133 == null) {
            throw new ZipException("InflaterInputStream is closed");
        }
        this.anInt1136 = this.anInputStream1133.read(this.aByteArray1135, 0, this.aByteArray1135.length);
        if (this.anInt1136 < 0) {
            throw new ZipException("Deflated stream ends early.");
        }
        this.aClass88_1134.setInput(this.aByteArray1135, 0, this.anInt1136);
    }
    
    public int read() throws IOException {
        if (this.read(this.aByteArray1137, 0, 1) > 0) {
            return this.aByteArray1137[0] & 0xFF;
        }
        return -1;
    }
    
    public final int read(final byte[] array) throws IOException {
        return this.read(array, 0, array.length);
    }
    
    public int read(final byte[] array, final int n, final int n2) throws IOException {
        if (this.aClass88_1134 == null) {
            throw new IOException("stream closed");
        }
        if (n2 == 0) {
            return 0;
        }
        while (true) {
            int method829;
            try {
                method829 = this.aClass88_1134.inflate(array, n, n2);
            }
            catch (DataFormatException class90) {
                throw new ZipException(class90.getMessage());
            }
            if (method829 > 0) {
                return method829;
            }
            if (this.aClass88_1134.needsDictionary() | this.aClass88_1134.finished()) {
                return -1;
            }
            if (!this.aClass88_1134.needsInput()) {
                throw new Error("Don't know what to do");
            }
            this.method850();
        }
    }
    
    public final long skip(long n) throws IOException {
        if (this.aClass88_1134 == null) {
            throw new IOException("stream closed");
        }
        if (n < 0L) {
            throw new IllegalArgumentException();
        }
        if (n == 0L) {
            return 0L;
        }
        int n2;
        byte[] array;
        long n3;
        int read;
        for (array = new byte[n2 = (int)Math.min(n, 2048L)], n3 = 0L; n > 0L && (read = this.read(array, 0, n2)) > 0; n -= read, n3 += read, n2 = (int)Math.min(n, 2048L)) {}
        return n3;
    }
    
    public final boolean markSupported() {
        return false;
    }
    
    public final void mark(final int n) {
    }
    
    public final void reset() throws IOException {
        throw new IOException("reset not supported");
    }
}
