package Centurion.lib.jazzlib;

import java.util.*;

public final class ZipEntry
{
    private static Calendar cal;
    private String name;
    private int anInt1066;
    private long aLong1067;
    private int anInt1068;
    private int anInt1069;
    private short aShort1070;
    private short aShort1071;
    private byte[] aByteArray1072;
    private String aString1073;
    int anInt1062;
    int offset;
    
    public ZipEntry(final String name) {
        super();
        this.aLong1067 = -1L;
        this.aShort1070 = 0;
        this.aShort1071 = -1;
        this.aByteArray1072 = null;
        this.aString1073 = null;
        final int length;
        if ((length = name.length()) > 65535) {
            throw new IllegalArgumentException("name length is " + length);
        }
        this.name = name;
    }
    
    final void setDOSTime(final int anInt1069) {
        this.anInt1069 = anInt1069;
        this.aShort1070 |= 0x8;
    }
    
    final int method772() {
        if ((this.aShort1070 & 0x8) == 0x0) {
            return 0;
        }
        return this.anInt1069;
    }
    
    public final String getName() {
        return this.name;
    }
    
    public final void method773(final long n) {
        final Calendar method788;
        final Calendar calendar = method788 = method788();
        synchronized (calendar) {
            method788.setTime(new Date(n));
            this.anInt1069 = ((method788.get(1) - 1980 & 0x7F) << 25 | method788.get(2) + 1 << 21 | method788.get(5) << 16 | method788.get(11) << 11 | method788.get(12) << 5 | method788.get(13) >> 1);
        }
        this.aShort1070 |= 0x8;
    }
    
    public final long method779() {
        this.method789();
        if ((this.aShort1070 & 0x8) == 0x0) {
            return -1L;
        }
        final int sec = 2 * (this.anInt1069 & 0x1F);
        final int min = this.anInt1069 >> 5 & 0x3F;
        final int hrs = this.anInt1069 >> 11 & 0x1F;
        final int day = this.anInt1069 >> 16 & 0x1F;
        final int mon = (this.anInt1069 >> 21 & 0xF) - 1;
        final int year = (this.anInt1069 >> 25 & 0x7F) + 1980;
        try {
            synchronized (ZipEntry.cal = method788()) {
                cal.set(1, year);
                cal.set(2, mon);
                cal.set(5, day);
                cal.set(11, hrs);
                cal.set(12, min);
                cal.set(13, sec);
                return ZipEntry.cal.getTime().getTime();
            }
        }
        catch (RuntimeException ex) {
            this.aShort1070 &= 0xFFFFFFF7;
            return -1L;
        }
    }
    
    private static synchronized Calendar method788() {
        if (ZipEntry.cal == null) {
            ZipEntry.cal = Calendar.getInstance();
        }
        return ZipEntry.cal;
    }
    
    public final void setSize(final long n) {
        if ((n & 0xFFFFFFFF00000000L) != 0x0L) {
            throw new IllegalArgumentException();
        }
        this.anInt1066 = (int)n;
        this.aShort1070 |= 0x1;
    }
    
    public final long method781() {
        if ((this.aShort1070 & 0x1) != 0x0) {
            return this.anInt1066 & 0xFFFFFFFFL;
        }
        return -1L;
    }
    
    public final void setCompressedSize(final long aLong1067) {
        this.aLong1067 = aLong1067;
    }
    
    public final long method783() {
        return this.aLong1067;
    }
    
    public final void setCrc(final long n) {
        if ((n & 0xFFFFFFFF00000000L) != 0x0L) {
            throw new IllegalArgumentException();
        }
        this.anInt1068 = (int)n;
        this.aShort1070 |= 0x4;
    }
    
    public final long getCrc() {
        if ((this.aShort1070 & 0x4) != 0x0) {
            return this.anInt1068 & 0xFFFFFFFFL;
        }
        return -1L;
    }
    
    public final void setMethod(final int n) {
        if (n != 0 && n != 8) {
            throw new IllegalArgumentException();
        }
        this.aShort1071 = (short)n;
    }
    
    public final int method785() {
        return this.aShort1071;
    }
    
    public final void setExtra(final byte[] aByteArray1072) {
        if (aByteArray1072 == null) {
            this.aByteArray1072 = null;
            return;
        }
        if (aByteArray1072.length > 65535) {
            throw new IllegalArgumentException();
        }
        this.aByteArray1072 = aByteArray1072;
    }
    
    private void method789() {
        if ((this.aShort1070 & 0x10) != 0x0) {
            return;
        }
        if (this.aByteArray1072 == null) {
            this.aShort1070 |= 0x10;
            return;
        }
        try {
            int n2;
            for (int i = 0; i < this.aByteArray1072.length; i += n2) {
                final int n = (this.aByteArray1072[i++] & 0xFF) | (this.aByteArray1072[i++] & 0xFF) << 8;
                n2 = ((this.aByteArray1072[i++] & 0xFF) | (this.aByteArray1072[i++] & 0xFF) << 8);
                if (n == 21589 && (this.aByteArray1072[i] & 0x1) != 0x0) {
                    this.method773((this.aByteArray1072[i + 1] & 0xFF) | (this.aByteArray1072[i + 2] & 0xFF) << 8 | (this.aByteArray1072[i + 3] & 0xFF) << 16 | (this.aByteArray1072[i + 4] & 0xFF) << 24);
                }
            }
        }
        catch (ArrayIndexOutOfBoundsException ex) {}
        this.aShort1070 |= 0x10;
    }
    
    public final byte[] method786() {
        return this.aByteArray1072;
    }
    
    public final void setComment(final String aString1073) {
        if (aString1073 != null && aString1073.length() > 65535) {
            throw new IllegalArgumentException();
        }
        this.aString1073 = aString1073;
    }
    
    public final String method787() {
        return this.aString1073;
    }
    
    public final String toString() {
        return this.name;
    }
    
    public final int hashCode() {
        return this.name.hashCode();
    }
}
