package Centurion.lib.jazzlib;

import java.io.*;

public final class ZipInputStream extends InflaterInputStream
{
    private CRC32 aClass86_1095;
    private ZipEntry aClass83_1096;
    private int anInt1097;
    private int anInt1098;
    private int anInt1099;
    private int anInt1100;
    private int anInt1101;
    private boolean aBoolean1102;
    
    public ZipInputStream(final InputStream inputStream) {
        super(inputStream, new Inflater(true));
        this.aClass86_1095 = new CRC32();
        this.aClass83_1096 = null;
    }
    
    private void method823() throws IOException {
        final int read = this.anInputStream1133.read(this.aByteArray1135, 0, this.aByteArray1135.length);
        this.anInt1136 = read;
        this.anInt1101 = read;
    }
    
    private int method818(final byte[] array, final int n, int anInt1101) throws IOException {
        if (this.anInt1101 <= 0) {
            this.method823();
            if (this.anInt1101 <= 0) {
                return -1;
            }
        }
        if (anInt1101 > this.anInt1101) {
            anInt1101 = this.anInt1101;
        }
        System.arraycopy(this.aByteArray1135, this.anInt1136 - this.anInt1101, array, n, anInt1101);
        this.anInt1101 -= anInt1101;
        return anInt1101;
    }
    
    private void method819(final byte[] array) throws IOException {
        int n = 0;
        int method818;
        for (int i = array.length; i > 0; i -= method818) {
            if ((method818 = this.method818(array, n, i)) == -1) {
                throw new EOFException();
            }
            n += method818;
        }
    }
    
    private int method824() throws IOException {
        if (this.anInt1101 <= 0) {
            this.method823();
            if (this.anInt1101 <= 0) {
                throw new ZipException("EOF in header");
            }
        }
        return this.aByteArray1135[this.anInt1136 - this.anInt1101--] & 0xFF;
    }
    
    private int method825() throws IOException {
        return this.method824() | this.method824() << 8;
    }
    
    private int method826() throws IOException {
        return this.method825() | this.method825() << 16;
    }
    
    public final ZipEntry method821() throws IOException {
        if (this.aClass86_1095 == null) {
            throw new IOException("Stream closed.");
        }
        if (this.aClass83_1096 != null) {
            this.method822();
        }
        final int method826;
        if ((method826 = this.method826()) == 33639248L) {
            this.close();
            return null;
        }
        if (method826 != 67324752L) {
            throw new ZipException("Wrong Local header signature: " + Integer.toHexString(method826));
        }
        this.method825();
        this.anInt1100 = this.method825();
        this.anInt1099 = this.method825();
        final int method827 = this.method826();
        final int method828 = this.method826();
        this.anInt1097 = this.method826();
        this.anInt1098 = this.method826();
        final int method829 = this.method825();
        final int method830 = this.method825();
        if (this.anInt1099 == 0 && this.anInt1097 != this.anInt1098) {
            throw new ZipException("Stored, but compressed != uncompressed");
        }
        final byte[] array = new byte[method829];
        this.method819(array);
        String s;
        try {
            s = new String(array, "UTF-8");
        }
        catch (Exception ex2) {
            try {
                s = new String(array);
            }
            catch (Exception ex) {
                throw new Error(ex.toString());
            }
        }
        this.aClass83_1096 = this.method820(s);
        this.aBoolean1102 = false;
        this.aClass83_1096.setMethod(this.anInt1099);
        if ((this.anInt1100 & 0x8) == 0x0) {
            this.aClass83_1096.setCrc((long)method828 & 0xFFFFFFFFL);
            this.aClass83_1096.setSize((long)this.anInt1098 & 0xFFFFFFFFL);
            this.aClass83_1096.setCompressedSize((long)this.anInt1097 & 0xFFFFFFFFL);
        }
        this.aClass83_1096.setDOSTime(method827);
        if (method830 > 0) {
            final byte[] array2 = new byte[method830];
            this.method819(array2);
            this.aClass83_1096.setExtra(array2);
        }
        if (this.anInt1099 == 8 && this.anInt1101 > 0) {
            System.arraycopy(this.aByteArray1135, this.anInt1136 - this.anInt1101, this.aByteArray1135, 0, this.anInt1101);
            this.anInt1136 = this.anInt1101;
            this.anInt1101 = 0;
            this.aClass88_1134.setInput(this.aByteArray1135, 0, this.anInt1136);
        }
        return this.aClass83_1096;
    }
    
    private void method827() throws IOException {
        if (this.method826() != 134695760L) {
            throw new ZipException("Data descriptor signature not found");
        }
        this.aClass83_1096.setCrc((long)this.method826() & 0xFFFFFFFFL);
        this.anInt1097 = this.method826();
        this.anInt1098 = this.method826();
        this.aClass83_1096.setSize((long)this.anInt1098 & 0xFFFFFFFFL);
        this.aClass83_1096.setCompressedSize((long)this.anInt1097 & 0xFFFFFFFFL);
    }
    
    public final void method822() throws IOException {
        if (this.aClass86_1095 == null) {
            throw new IOException("Stream closed.");
        }
        if (this.aClass83_1096 == null) {
            return;
        }
        if (this.anInt1099 == 8) {
            if ((this.anInt1100 & 0x8) != 0x0) {
                while (this.read(new byte[2048]) > 0) {}
                return;
            }
            this.anInt1097 -= this.aClass88_1134.getTotalIn();
            this.anInt1101 = this.aClass88_1134.getRemaining();
        }
        if (this.anInt1101 > this.anInt1097 && this.anInt1097 >= 0) {
            this.anInt1101 -= this.anInt1097;
        }
        else {
            this.anInt1097 -= this.anInt1101;
            this.anInt1101 = 0;
            while (this.anInt1097 != 0) {
                final long skip;
                if ((skip = this.anInputStream1133.skip((long)this.anInt1097 & 0xFFFFFFFFL)) <= 0L) {
                    throw new ZipException("zip archive ends early.");
                }
                this.anInt1097 -= skip;
            }
        }
        this.anInt1098 = 0;
        this.aClass86_1095.method816();
        if (this.anInt1099 == 8) {
            this.aClass88_1134.reset();
        }
        this.aClass83_1096 = null;
        this.aBoolean1102 = true;
    }
    
    public final int available() throws IOException {
        if (this.aBoolean1102) {
            return 0;
        }
        return 1;
    }
    
    public final int read() throws IOException {
        final byte[] array = { 0 };
        if (this.read(array, 0, 1) <= 0) {
            return -1;
        }
        return array[0] & 0xFF;
    }
    
    public final int read(final byte[] array, final int n, int n2) throws IOException {
        if (n2 == 0) {
            return 0;
        }
        if (this.aClass86_1095 == null) {
            throw new IOException("Stream closed.");
        }
        if (this.aClass83_1096 == null) {
            return -1;
        }
        boolean b = false;
        switch (this.anInt1099) {
            case 8:
                if ((n2 = super.read(array, n, n2)) >= 0) {
                    break;
                }
                if (!this.aClass88_1134.finished()) {
                    throw new ZipException("Inflater not finished!?");
                }
                this.anInt1101 = this.aClass88_1134.getRemaining();
                if ((this.anInt1100 & 0x8) != 0x0) {
                    this.method827();
                }
                if (this.aClass88_1134.getTotalIn() != this.anInt1097 || this.aClass88_1134.getTotalOut() != this.anInt1098) {
                    throw new ZipException("size mismatch: " + this.anInt1097 + ";" + this.anInt1098 + " <-> " + this.aClass88_1134.getTotalIn() + ";" + this.aClass88_1134.getTotalOut());
                }
                this.aClass88_1134.reset();
                b = true;
                break;
            case 0:
                if (n2 > this.anInt1097 && this.anInt1097 >= 0) {
                    n2 = this.anInt1097;
                }
                if ((n2 = this.method818(array, n, n2)) > 0) {
                    this.anInt1097 -= n2;
                    this.anInt1098 -= n2;
                }
                if (this.anInt1097 == 0) {
                    b = true;
                    break;
                }
                if (n2 < 0) {
                    throw new ZipException("EOF in stored block");
                }
                break;
        }
        if (n2 > 0) {
            this.aClass86_1095.method814(array, n, n2);
        }
        if (b) {
            if ((this.aClass86_1095.getValue() & 0xFFFFFFFFL) != this.aClass83_1096.getCrc()) {
                throw new ZipException("CRC mismatch");
            }
            this.aClass86_1095.method816();
            this.aClass83_1096 = null;
            this.aBoolean1102 = true;
        }
        return n2;
    }
    
    public final void close() throws IOException {
        super.close();
        this.aClass86_1095 = null;
        this.aClass83_1096 = null;
        this.aBoolean1102 = true;
    }
    
    protected final ZipEntry method820(final String s) {
        return new ZipEntry(s);
    }
}
