package Centurion.lib.jazzlib;

import java.io.*;
import java.util.*;

public final class ZipOutputStream extends DeflaterOutputStream
{
    private Vector aVector1247;
    private CRC32 crc;
    private ZipEntry curEntry;
    private int anInt1250;
    private int anInt1251;
    private int anInt1252;
    private byte[] aByteArray1253;
    private int anInt1254;
    static final char[] aCharArray1246;
    
    public ZipOutputStream(final OutputStream outputStream) {
        super(outputStream, new Deflater(-1, true));
        this.aVector1247 = new Vector();
        this.crc = new CRC32();
        this.curEntry = null;
        this.anInt1252 = 0;
        this.aByteArray1253 = new byte[0];
        this.anInt1254 = 8;
    }
    
    public final void method927(final int anInt1254) {
        if (anInt1254 != 0 && anInt1254 != 8) {
            throw new IllegalArgumentException("Method not supported.");
        }
        this.anInt1254 = anInt1254;
    }
    
    public final void method930(final int n) {
        this.aClass85_1219.setLevel(n);
    }
    
    private void method932(final int n) throws IOException {
        this.anOutputStream1217.write(n & 0xFF);
        this.anOutputStream1217.write(n >> 8 & 0xFF);
    }
    
    private void method934(final int n) throws IOException {
        this.method932(n);
        this.method932(n >> 16);
    }
    
    private void method928(final long n) throws IOException {
        this.method934((int)n);
    }
    
    public final void store(final ZipEntry aClass83_1249) throws IOException {
        if (this.aVector1247 == null) {
            throw new ZipException("ZipOutputStream was finished");
        }
        int anInt1250 = aClass83_1249.method785();
        int anInt1251 = 0;
        if (anInt1250 == -1) {
            anInt1250 = this.anInt1254;
        }
        if (anInt1250 == 0) {
            if (aClass83_1249.method783() >= 0L) {
                if (aClass83_1249.method781() < 0L) {
                    aClass83_1249.setSize(aClass83_1249.method783());
                }
                else if (aClass83_1249.method781() != aClass83_1249.method783()) {
                    throw new ZipException("Method STORED, but compressed size != size");
                }
            }
            else {
                aClass83_1249.setCompressedSize(aClass83_1249.method781());
            }
            if (aClass83_1249.method781() < 0L) {
                throw new ZipException("Method STORED, but size not set");
            }
            if (aClass83_1249.getCrc() < 0L) {
                throw new ZipException("Method STORED, but crc not set");
            }
        }
        else if (anInt1250 == 8 && (aClass83_1249.method783() < 0L || aClass83_1249.method781() < 0L || aClass83_1249.getCrc() < 0L)) {
            anInt1251 = 8;
        }
        if (this.curEntry != null) {
            this.method933();
        }
        if (aClass83_1249.method779() < 0L) {
            aClass83_1249.method773(System.currentTimeMillis());
        }
        aClass83_1249.anInt1062 = anInt1251;
        aClass83_1249.offset = this.anInt1252;
        aClass83_1249.setMethod(anInt1250);
        this.anInt1250 = anInt1250;
        this.method928(67324752L);
        this.method932((anInt1250 == 0) ? 10 : 20);
        this.method932(anInt1251);
        this.method932(anInt1250);
        this.method934(aClass83_1249.method772());
        if ((anInt1251 & 0x8) == 0x0) {
            this.method934((int)aClass83_1249.getCrc());
            this.method934((int)aClass83_1249.method783());
            this.method934((int)aClass83_1249.method781());
        }
        else {
            this.method934(0);
            this.method934(0);
            this.method934(0);
        }
        byte[] bytes;
        try {
            bytes = aClass83_1249.getName().getBytes("UTF-8");
        }
        catch (UnsupportedEncodingException ex) {
            throw new Error(ex.toString());
        }
        if (bytes.length > 65535) {
            throw new ZipException("Name too long.");
        }
        byte[] method786;
        if ((method786 = aClass83_1249.method786()) == null) {
            method786 = new byte[0];
        }
        this.method932(bytes.length);
        this.method932(method786.length);
        this.anOutputStream1217.write(bytes);
        this.anOutputStream1217.write(method786);
        this.anInt1252 += 30 + bytes.length + method786.length;
        this.curEntry = aClass83_1249;
        this.crc.method816();
        if (anInt1250 == 8) {
            this.aClass85_1219.reset();
        }
        this.anInt1251 = 0;
    }
    
    public final void method933() throws IOException {
        if (this.curEntry == null) {
            throw new ZipException("No open entry");
        }
        if (this.anInt1250 == 8) {
            super.method917();
        }
        final int n = (this.anInt1250 == 8) ? this.aClass85_1219.getTotalOut() : this.anInt1251;
        if (this.curEntry.method781() < 0L) {
            this.curEntry.setSize(this.anInt1251);
        }
        else if (this.curEntry.method781() != this.anInt1251) {
            throw new ZipException("size was " + this.anInt1251 + ", but I expected " + this.curEntry.method781());
        }
        if (this.curEntry.method783() < 0L) {
            this.curEntry.setCompressedSize(n);
        }
        else if (this.curEntry.method783() != n) {
            throw new ZipException("compressed size was " + n + ", but I expected " + this.curEntry.method781());
        }
        if (this.curEntry.getCrc() < 0L) {
            this.curEntry.setCrc(this.crc.getValue());
        }
        else if (this.curEntry.getCrc() != this.crc.getValue()) {
            throw new ZipException("crc was " + toHexString(this.crc.getValue()) + ", but I expected " + toHexString(this.curEntry.getCrc()));
        }
        this.anInt1252 += n;
        if (this.anInt1250 == 8 && (this.curEntry.anInt1062 & 0x8) != 0x0) {
            this.method928(134695760L);
            this.method934((int)this.curEntry.getCrc());
            this.method934((int)this.curEntry.method783());
            this.method934((int)this.curEntry.method781());
            this.anInt1252 += 16;
        }
        this.aVector1247.addElement(this.curEntry);
        this.curEntry = null;
    }
    
    public final void write(final byte[] array, final int n, final int n2) throws IOException {
        if (this.curEntry == null) {
            throw new ZipException("No open entry.");
        }
        switch (this.anInt1250) {
            case 8:
                super.write(array, n, n2);
                break;
            case 0:
                this.anOutputStream1217.write(array, n, n2);
                break;
        }
        this.crc.method814(array, n, n2);
        this.anInt1251 += n2;
    }
    
    public final void method917() throws IOException {
        if (this.aVector1247 == null) {
            return;
        }
        if (this.curEntry != null) {
            this.method933();
        }
        int n = 0;
        int n2 = 0;
        final Enumeration elements = this.aVector1247.elements();
        while (elements.hasMoreElements()) {
            final ZipEntry class83;
            final int method785 = (class83 = (ZipEntry) elements.nextElement()).method785();
            this.method928(33639248L);
            this.method932((method785 == 0) ? 10 : 20);
            this.method932((method785 == 0) ? 10 : 20);
            this.method932(class83.anInt1062);
            this.method932(method785);
            this.method934(class83.method772());
            this.method934((int)class83.getCrc());
            this.method934((int)class83.method783());
            this.method934((int)class83.method781());
            byte[] bytes;
            try {
                bytes = class83.getName().getBytes("UTF-8");
            }
            catch (UnsupportedEncodingException ex) {
                throw new Error(ex.toString());
            }
            if (bytes.length > 65535) {
                throw new ZipException("Name too long.");
            }
            byte[] method786;
            if ((method786 = class83.method786()) == null) {
                method786 = new byte[0];
            }
            final String method787 = class83.method787();
            byte[] array;
            try {
                array = ((method787 != null) ? method787.getBytes("UTF-8") : new byte[0]);
            }
            catch (UnsupportedEncodingException ex2) {
                throw new Error(ex2.toString());
            }
            if (array.length > 65535) {
                throw new ZipException("Comment too long.");
            }
            this.method932(bytes.length);
            this.method932(method786.length);
            this.method932(array.length);
            this.method932(0);
            this.method932(0);
            this.method934(0);
            this.method934(class83.offset);
            this.anOutputStream1217.write(bytes);
            this.anOutputStream1217.write(method786);
            this.anOutputStream1217.write(array);
            ++n;
            n2 += 46 + bytes.length + method786.length + array.length;
        }
        this.method928(101010256L);
        this.method932(0);
        this.method932(0);
        this.method932(n);
        this.method932(n);
        this.method934(n2);
        this.method934(this.anInt1252);
        this.method932(this.aByteArray1253.length);
        this.anOutputStream1217.write(this.aByteArray1253);
        this.anOutputStream1217.flush();
        this.aVector1247 = null;
    }
    
    private static String toHexString(long n) {
        if (n >= 0L && (int)n == n) {
            return Integer.toHexString((int)n);
        }
        final char[] array = new char[64];
        int n2 = 64;
        do {
            array[--n2] = ZipOutputStream.aCharArray1246[(int)n & 0xF];
        } while ((n >>>= 4) != 0L);
        return new String(array, n2, 64 - n2);
    }
    
    static {
        aCharArray1246 = new char[] { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f' };
    }
}
